package com.diagbot.facade;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.diagbot.client.QcServiceClient;
import com.diagbot.dto.BehospitalInfoDTO;
import com.diagbot.dto.OutputInfo;
import com.diagbot.dto.QcCasesEntryDTO;
import com.diagbot.dto.Response;
import com.diagbot.service.impl.BehospitalInfoServiceImpl;
import com.diagbot.util.SysUserUtils;
import com.diagbot.vo.AnalyzeVO;
import com.diagbot.vo.BehospitalPageVO;
import com.diagbot.vo.QueryVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: zhoutg
 * @time: 2020/4/12 11:39
 */
@Component
public class BehospitalInfoFacade extends BehospitalInfoServiceImpl {

    @Autowired
    QcServiceClient qcServiceClient;
    @Autowired
    private QcCasesEntryFacade qcCasesEntryFacade;

    public IPage<BehospitalInfoDTO> pageFac(BehospitalPageVO behospitalPageVO) {

        behospitalPageVO.setHospitalId(SysUserUtils.getCurrentHospitalID());
        IPage<BehospitalInfoDTO> res = getPage(behospitalPageVO);
        List<BehospitalInfoDTO> behospitalInfoDTOList = res.getRecords();
        for (BehospitalInfoDTO behospitalInfo : behospitalInfoDTOList) {
            if (behospitalInfo != null && behospitalInfo.getBirthday() != null) {
                behospitalInfo.setAge(getAge(behospitalInfo.getBirthday()));
            }
        }
        return res;
    }


    public Map<String, Object> analyze(AnalyzeVO analyzeVO) {

        //获取质控条目
        List<QcCasesEntryDTO> qcCasesEntryDTOList = qcCasesEntryFacade.getQcCasesEntry(analyzeVO);

        // TODO 获取病历所有数据

        // TODO 拼接数据

        // TODO 调用质控接口
        QueryVo queryVo = new QueryVo();
        Response<OutputInfo> response = qcServiceClient.extract(queryVo);

        // 评分，保存


        return null;
    }

    /**
     * 通过日期计算年龄
     *
     * @param birthDay
     * @return
     */
    public int getAge(Date birthDay) {
        Calendar cal = Calendar.getInstance();
        if (cal.before(birthDay)) { //出生日期晚于当前时间，无法计算
            return 0;
            //            throw new IllegalArgumentException(
            //                    "The birthDay is before Now.It's unbelievable!");
        }
        int yearNow = cal.get(Calendar.YEAR);  //当前年份
        int monthNow = cal.get(Calendar.MONTH);  //当前月份
        int dayOfMonthNow = cal.get(Calendar.DAY_OF_MONTH); //当前日期
        cal.setTime(birthDay);
        int yearBirth = cal.get(Calendar.YEAR);
        int monthBirth = cal.get(Calendar.MONTH);
        int dayOfMonthBirth = cal.get(Calendar.DAY_OF_MONTH);
        int age = yearNow - yearBirth;   //计算整岁数
        if (monthNow <= monthBirth) {
            if (monthNow == monthBirth) {
                if (dayOfMonthNow < dayOfMonthBirth) {
                    age--;//当前日期在生日之前，年龄减一
                }
            } else {
                age--;//当前月份在生日之前，年龄减一
            }
        }
        if (age < 0) {
            return 0;
        }
        return age;
    }
}
