package com.diagbot.web;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.diagbot.annotation.SysLogger;
import com.diagbot.dto.BehospitalInfoDTO;
import com.diagbot.dto.RespDTO;
import com.diagbot.facade.BehospitalInfoFacade;
import com.diagbot.vo.AnalyzeVO;
import com.diagbot.vo.BehospitalPageVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * <p>
 * 住院病历信息 前端控制器
 * </p>
 *
 * @author zhoutg
 * @since 2020-04-13
 */
@RestController
@RequestMapping("/qc/behospitalInfo")
@Api(value = "病历API", tags = { "病历API" })
public class BehospitalInfoController {
    @Autowired
    BehospitalInfoFacade behospitalInfoFacade;

    @ApiOperation(value = "病历分页列表[by:zhoutg]",
            notes = "")
    @PostMapping("/page")
    @SysLogger("page")
    public RespDTO<IPage<BehospitalInfoDTO>> page(@RequestBody BehospitalPageVO behospitalPageVO) {
        IPage<BehospitalInfoDTO> data = behospitalInfoFacade.pageFac(behospitalPageVO);
        return RespDTO.onSuc(data);
    }


    @ApiOperation(value = "评分[by:zhoutg]",
            notes = "")
    @PostMapping("/analyze")
    @SysLogger("analyze")
    public RespDTO<IPage<BehospitalInfoDTO>> analyze(@RequestBody AnalyzeVO analyzeVO) {
        Map<String, Object> data = behospitalInfoFacade.analyze(analyzeVO);
        return RespDTO.onSuc(data);
    }
}
